unit Unit3;

interface

uses windows, graphics;

const OFN_EXPLORER = $00080000;
      OFN_NONETWORKBUTTON = $00020000;
      OFN_HIDEREADONLY = $00000004;
      b1x=7;   //    
      b1y=7;
      b1w=75;
      b1h=25;

      b2x=7;
      b2y=40;
      b2w=75;
      b2h=25;

      b3x=7;
      b3y=73;
      b3w=75;
      b3h=25;
      
type
 poin = record
  x,y:extended; // . 
  dx,dy:extended;//   
 end;

 trgb = record  //,      ,     
  b,g,r: byte;
 end;

 ARGB = array [0..0] of TRGB;
 PARGB = ^ARGB;

 tagOFNA = packed record
   lStructSize: DWORD;
   hWndOwner: HWND;
   hInstance: HINST;
   lpstrFilter: PAnsiChar;
   lpstrCustomFilter: PAnsiChar;
   nMaxCustFilter: DWORD;
   nFilterIndex: DWORD;
   lpstrFile: PAnsiChar;
   nMaxFile: DWORD;
   lpstrFileTitle: PAnsiChar;
   nMaxFileTitle: DWORD;
   lpstrInitialDir: PAnsiChar;
   lpstrTitle: PAnsiChar;
   Flags: DWORD;
   nFileOffset: Word;
   nFileExtension: Word;
   lpstrDefExt: PAnsiChar;
   lCustData: LPARAM;
   lpfnHook: function(Wnd: HWND; Msg: UINT; wParam: WPARAM; lParam: LPARAM): UINT stdcall;
   lpTemplateName: PAnsiChar;
 end;

var
  MainWND:thandle;
  hFontBold: THandle;
  WC: TWndClass;
  Mesg:TMsg;
  but1,but2,but3: THandle;

  sour: tbitmap; //,   
  px,py: integer; //    
  prevx, prevy: integer; //    
  dragtrig: boolean = false;
  ps,pr:array of PARGB;  //       Pointer Sours, Pointer Result
  shad:integer;
  orw,orh:integer; //      
  points: array of poin;
  activ, trig, rn:boolean;//    
  wrt,grt,r1,r2:trect;   //Work RecT (  ) Graphic RecT
  count:cardinal;
  Thr: longword;
  ofn: tagOFNA;
  oFilterIndex: DWORD;
  counter,unocount:int64;

function GetMid(t:trect):trgb;
procedure Concrete(rect:trect; s:char);

implementation

function GetMid(t:trect):trgb;
 var i,j:integer;
     r,g,b:int64;
begin
 r:=0;
 g:=0;
 b:=0;
 for i:=t.Top to t.Bottom do
  for j:=t.Left to t.Right do begin
   r:=r+ps[i,j].r;
   g:=g+ps[i,j].g;
   b:=b+ps[i,j].b;
  end;
 i:=(t.Bottom-t.Top+1)*(t.Right-t.Left+1);
 result.r:=r div i;
 result.g:=g div i;
 result.b:=b div i;
end;

procedure Concrete(rect:trect; s:char);
 function GetMiddle(t:trect):extended;
  var i,j:integer;
 begin
  result:=0;
  for i:=t.Top to t.Bottom do
   for j:=t.Left to t.Right do
    result:=result+ps[i,j].r;
  result:=result/((t.Bottom-t.Top+1)*(t.Right-t.Left+1));
 end;

 var bal:extended; rec1,rec2:trect;
begin
 bal:=GetMiddle(rect); //     R  

 if bal=0 then begin  //   
  inc(counter);
  if ((rect.Right-rect.Left+1)*(rect.Bottom-rect.Top+1))=1 then inc(unocount);
  sour.Canvas.Brush.Color:=random(256)+255*random(256)+65535*random(256);
  inc(rect.Bottom);//     ,     
  inc(rect.Right);
  sour.Canvas.FillRect(rect);
  exit;
 end;

 if bal=255 then exit;

 if s='V' then begin // Vertical separation
  rec1.Top:=rect.Top;
  rec1.Bottom:=rect.bottom;
  rec1.Left:=rect.left;
  rec1.Right:=rect.left+(rect.Right-rect.Left)div 2;

  rec2.Top:=rect.Top;
  rec2.Bottom:=rect.Bottom;
  rec2.Left:=rec1.Right+1;
  rec2.Right:=rect.Right;

  if rec1.Right>=rec1.Left then concrete(rec1,'H');
  if rec2.Right>=rec2.Left then concrete(rec2,'H');
 end else begin  //  Horizontal separation
  rec1.Left:=rect.Left;
  rec1.Right:=rect.Right;
  rec1.Top:=rect.Top;
  rec1.Bottom:=rect.Top+(rect.bottom-rect.top)div 2;

  rec2.Left:=rect.Left;
  rec2.Right:=rect.Right;
  rec2.Top:=rec1.bottom+1;
  rec2.Bottom:=rect.Bottom;

  if rec1.bottom>=rec1.top then concrete(rec1,'V');
  if rec2.bottom>=rec2.top then concrete(rec2,'V');
 end;
end;

end.
 